if(!Tonyu.load)Tonyu.load=(_,f)=>f();
Tonyu.load({"compiler":{"namespace":"user","defaultSuperClass":"kernel.Actor","dependingProjects":[{"namespace":"kernel"}]},"run":{"mainClass":"user.Main","bootClass":"kernel.Boot","globals":{"$defaultFPS":60,"$imageSmoothingDisabled":true,"$soundLoadAndDecode":false}},"plugins":{},"kernelEditable":false,"language":"tonyu","version":1719213854291}, ()=>{
Tonyu.klass.define({
  fullName: 'user.Aim',
  shortName: 'Aim',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Aim_main() {
        var _this=this;
        
        _this.p=Tonyu.globals.$pat_pad128+3;
        _this.zOrder=(- 10);
        _this.crashScale=0.5;
        _this.scaleX=0.5;
        _this.scaleY=0.5;
        while (true) {
          Tonyu.checkLoop();
          _this.x=Tonyu.globals.$mouseX;
          _this.y=Tonyu.globals.$mouseY;
          if (! Tonyu.globals.$touches[0].touched==1) {
            _this.hide();
            
          } else {
            _this.show();
            
          }
          _this.update();
          
        }
      },
      fiber$main :function* _trc_Aim_f_main(_thread) {
        var _this=this;
        
        _this.p=Tonyu.globals.$pat_pad128+3;
        _this.zOrder=(- 10);
        _this.crashScale=0.5;
        _this.scaleX=0.5;
        _this.scaleY=0.5;
        while (true) {
          yield null;
          _this.x=Tonyu.globals.$mouseX;
          _this.y=Tonyu.globals.$mouseY;
          if (! Tonyu.globals.$touches[0].touched==1) {
            _this.hide();
            
          } else {
            _this.show();
            
          }
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Bullet',
  shortName: 'Bullet',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Bullet_main() {
        var _this=this;
        
        _this.useObjectPool=true;
        _this.crashScale=0.5;
        _this.scaleX=0.5;
        _this.scaleY=0.5;
        _this.dx=Tonyu.globals.$aim.x-_this.x;
        _this.dy=Tonyu.globals.$aim.y-_this.y;
        _this.dir=_this.atanxy(_this.dx,_this.dy);
        _this.vx=_this.cos(_this.dir)*10;
        _this.vy=_this.sin(_this.dir)*10;
        while (! _this.screenOut()) {
          Tonyu.checkLoop();
          _this.rotation=_this.dir+90;
          _this.x+=_this.vx;
          _this.y+=_this.vy;
          _this.update();
          _this.cSam=_this.crashTo(Tonyu.classes.user.Sam);
          if (_this.cSam) {
            _this.die();
          }
          
        }
        _this.die();
      },
      fiber$main :function* _trc_Bullet_f_main(_thread) {
        var _this=this;
        
        _this.useObjectPool=true;
        _this.crashScale=0.5;
        _this.scaleX=0.5;
        _this.scaleY=0.5;
        _this.dx=Tonyu.globals.$aim.x-_this.x;
        _this.dy=Tonyu.globals.$aim.y-_this.y;
        _this.dir=_this.atanxy(_this.dx,_this.dy);
        _this.vx=_this.cos(_this.dir)*10;
        _this.vy=_this.sin(_this.dir)*10;
        while (! _this.screenOut()) {
          yield null;
          _this.rotation=_this.dir+90;
          _this.x+=_this.vx;
          _this.y+=_this.vy;
          (yield* _this.fiber$update(_thread));
          _this.cSam=_this.crashTo(Tonyu.classes.user.Sam);
          if (_this.cSam) {
            _this.die();
          }
          
        }
        _this.die();
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}}},"fields":{"dx":{},"dy":{},"dir":{},"vx":{},"vy":{},"cSam":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Item',
  shortName: 'Item',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Item_main() {
        var _this=this;
        
        _this.useObjectPool=true;
        _this.crashScale=0.5;
        _this.counter=0;
        while (true) {
          Tonyu.checkLoop();
          _this.counter++;
          if (_this.floor(_this.counter/240)) {
            _this.die();
          }
          _this.cAim=_this.crashTo(Tonyu.classes.user.Aim);
          if ((! Tonyu.globals.$touches[0].touched==0)&&(_this.cAim)) {
            _this.parallel("animate");
            
          }
          _this.update();
          
        }
      },
      fiber$main :function* _trc_Item_f_main(_thread) {
        var _this=this;
        
        _this.useObjectPool=true;
        _this.crashScale=0.5;
        _this.counter=0;
        while (true) {
          yield null;
          _this.counter++;
          if (_this.floor(_this.counter/240)) {
            _this.die();
          }
          _this.cAim=_this.crashTo(Tonyu.classes.user.Aim);
          if ((! Tonyu.globals.$touches[0].touched==0)&&(_this.cAim)) {
            _this.parallel("animate");
            
          }
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      animate :function _trc_Item_animate() {
        var _this=this;
        
        _this.counter=0;
        while (true) {
          Tonyu.checkLoop();
          _this.counter++;
          _this.y--;
          if (_this.floor(_this.counter/60)) {
            Tonyu.globals.$money+=(1);
            _this.die();
            
          }
          _this.update();
          
        }
      },
      fiber$animate :function* _trc_Item_f_animate(_thread) {
        var _this=this;
        
        _this.counter=0;
        while (true) {
          yield null;
          _this.counter++;
          _this.y--;
          if (_this.floor(_this.counter/60)) {
            Tonyu.globals.$money+=(1);
            _this.die();
            
          }
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}},"animate":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}}},"fields":{"counter":{},"cAim":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        var _this=this;
        
        _this.update();
        Tonyu.globals.$Screen.resize(1024,1280);
        Tonyu.globals.$Screen.setBGColor("lightgreen");
        Tonyu.globals.$sl=0;
        Tonyu.globals.$aim=new Tonyu.classes.user.Aim;
        Tonyu.globals.$towerHP=10;
        Tonyu.globals.$ip=0;
        Tonyu.globals.$attack=9;
        Tonyu.globals.$money=0;
        Tonyu.globals.$ep=0;
        Tonyu.globals.$wave=_this.clamp(1,1,1000);
        Tonyu.globals.$healthPlice=1;
        Tonyu.globals.$armPlice=5;
        Tonyu.globals.$brankPlice=0;
        new Tonyu.classes.kernel.Label({template: "$money PROTEIN",x: Tonyu.globals.$screenWidth/2-128,y: 16,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
        new Tonyu.classes.kernel.Label({template: "$ep EP",x: Tonyu.globals.$screenWidth/2+128,y: 16,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
        new Tonyu.classes.kernel.Label({template: "WAVE:$wave",x: Tonyu.globals.$screenWidth/2,y: 80,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
        new Tonyu.classes.kernel.Label({template: "Sam.length =  $sl",x: Tonyu.globals.$screenWidth/2+386,y: Tonyu.globals.$screenHeight-32,size: 24,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
        _this.fstart=("off");
        _this.Standby();
        while (true) {
          Tonyu.checkLoop();
          Tonyu.globals.$sl=_this.all(Tonyu.classes.user.Sam).length;
          if ((_this.all(Tonyu.classes.user.Sam).length==0)&&(_this.fstart==("on"))) {
            Tonyu.globals.$wave+=1;
            _this.Healing();
            _this.Fight();
            
          }
          if ((_this.all(Tonyu.classes.user.Tower).length==0)&&(_this.fstart==("on"))) {
            _this.Defeat();
          }
          _this.update();
          
        }
        ;
        
        ;
        
      },
      fiber$main :function* _trc_Main_f_main(_thread) {
        var _this=this;
        
        (yield* _this.fiber$update(_thread));
        Tonyu.globals.$Screen.resize(1024,1280);
        Tonyu.globals.$Screen.setBGColor("lightgreen");
        Tonyu.globals.$sl=0;
        Tonyu.globals.$aim=new Tonyu.classes.user.Aim;
        Tonyu.globals.$towerHP=10;
        Tonyu.globals.$ip=0;
        Tonyu.globals.$attack=9;
        Tonyu.globals.$money=0;
        Tonyu.globals.$ep=0;
        Tonyu.globals.$wave=_this.clamp(1,1,1000);
        Tonyu.globals.$healthPlice=1;
        Tonyu.globals.$armPlice=5;
        Tonyu.globals.$brankPlice=0;
        new Tonyu.classes.kernel.Label({template: "$money PROTEIN",x: Tonyu.globals.$screenWidth/2-128,y: 16,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
        new Tonyu.classes.kernel.Label({template: "$ep EP",x: Tonyu.globals.$screenWidth/2+128,y: 16,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
        new Tonyu.classes.kernel.Label({template: "WAVE:$wave",x: Tonyu.globals.$screenWidth/2,y: 80,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
        new Tonyu.classes.kernel.Label({template: "Sam.length =  $sl",x: Tonyu.globals.$screenWidth/2+386,y: Tonyu.globals.$screenHeight-32,size: 24,layer: Tonyu.globals.$mainLayer,fillStyle: "#000",align: "center"});
        _this.fstart=("off");
        (yield* _this.fiber$Standby(_thread));
        while (true) {
          yield null;
          Tonyu.globals.$sl=_this.all(Tonyu.classes.user.Sam).length;
          if ((_this.all(Tonyu.classes.user.Sam).length==0)&&(_this.fstart==("on"))) {
            Tonyu.globals.$wave+=1;
            (yield* _this.fiber$Healing(_thread));
            (yield* _this.fiber$Fight(_thread));
            
          }
          if ((_this.all(Tonyu.classes.user.Tower).length==0)&&(_this.fstart==("on"))) {
            (yield* _this.fiber$Defeat(_thread));
          }
          (yield* _this.fiber$update(_thread));
          
        }
        ;
        
        ;
        
        
      },
      Alldie :function _trc_Main_Alldie() {
        var _this=this;
        
        _this.print("@Main.Alldie");
        Tonyu.globals.$frontLayer.all(Tonyu.classes.kernel.Label).die();
        Tonyu.globals.$frontLayer.all(Tonyu.classes.kernel.Button).die();
        _this.all(Tonyu.classes.user.Sam).die();
      },
      fiber$Alldie :function* _trc_Main_f_Alldie(_thread) {
        var _this=this;
        
        _this.print("@Main.Alldie");
        Tonyu.globals.$frontLayer.all(Tonyu.classes.kernel.Label).die();
        Tonyu.globals.$frontLayer.all(Tonyu.classes.kernel.Button).die();
        _this.all(Tonyu.classes.user.Sam).die();
        
      },
      Standby :function _trc_Main_Standby() {
        var _this=this;
        
        _this.print("@Main.Standby");
        Tonyu.globals.$tower=new Tonyu.classes.user.Tower;
        _this.Pupgrade();
        new Tonyu.classes.kernel.Label({template: "READY?",x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2-192,size: 128,fillStyle: "#000",align: "center"});
        new Tonyu.classes.kernel.Button({text: "GO!",fillStyle: "#000",strokeStyle: "#fff",clickedStyle: "#000",left: (Tonyu.globals.$screenWidth/2)-240,top: (Tonyu.globals.$screenHeight/2)+96,width: 480,height: 128,padding: 8,onClick: (function anonymous_3059() {
          
          _this.Alldie();
          _this.Eupgrade();
          _this.Fight();
        })});
      },
      fiber$Standby :function* _trc_Main_f_Standby(_thread) {
        var _this=this;
        
        _this.print("@Main.Standby");
        Tonyu.globals.$tower=new Tonyu.classes.user.Tower;
        (yield* _this.fiber$Pupgrade(_thread));
        new Tonyu.classes.kernel.Label({template: "READY?",x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2-192,size: 128,fillStyle: "#000",align: "center"});
        new Tonyu.classes.kernel.Button({text: "GO!",fillStyle: "#000",strokeStyle: "#fff",clickedStyle: "#000",left: (Tonyu.globals.$screenWidth/2)-240,top: (Tonyu.globals.$screenHeight/2)+96,width: 480,height: 128,padding: 8,onClick: (function anonymous_3059() {
          
          _this.Alldie();
          _this.Eupgrade();
          _this.Fight();
        })});
        
      },
      Fight :function _trc_Main_Fight() {
        var _this=this;
        
        _this.print("@Main.Fight");
        _this.fstart=("on");
        for (_this.i=0; _this.i<4+(Tonyu.globals.$wave) ; _this.i++) {
          Tonyu.checkLoop();
          _this.appear(Tonyu.classes.user.Sam);
        }
      },
      fiber$Fight :function* _trc_Main_f_Fight(_thread) {
        var _this=this;
        
        _this.print("@Main.Fight");
        _this.fstart=("on");
        for (_this.i=0; _this.i<4+(Tonyu.globals.$wave) ; _this.i++) {
          yield null;
          _this.appear(Tonyu.classes.user.Sam);
        }
        
      },
      Healing :function _trc_Main_Healing() {
        var _this=this;
        
        _this.print("@Main.Healing");
      },
      fiber$Healing :function* _trc_Main_f_Healing(_thread) {
        var _this=this;
        
        _this.print("@Main.Healing");
        
      },
      Defeat :function _trc_Main_Defeat() {
        var _this=this;
        
        _this.print("@Main.Defeat");
        _this.fstart=("off");
        new Tonyu.classes.kernel.Button({text: "DEFEAT...",fillStyle: "#0008",strokeStyle: "#fff",clickedStyle: "#000",left: 0,top: 0,width: Tonyu.globals.$screenWidth,height: Tonyu.globals.$screenHeight,padding: 64,onClick: (function anonymous_3543() {
          
          _this.Alldie();
          Tonyu.globals.$mainLayer.all(Tonyu.classes.kernel.Panel).die();
          if (Tonyu.globals.$wave>1) {
            Tonyu.globals.$wave--;
          }
          _this.Standby();
        })});
      },
      fiber$Defeat :function* _trc_Main_f_Defeat(_thread) {
        var _this=this;
        
        _this.print("@Main.Defeat");
        _this.fstart=("off");
        new Tonyu.classes.kernel.Button({text: "DEFEAT...",fillStyle: "#0008",strokeStyle: "#fff",clickedStyle: "#000",left: 0,top: 0,width: Tonyu.globals.$screenWidth,height: Tonyu.globals.$screenHeight,padding: 64,onClick: (function anonymous_3543() {
          
          _this.Alldie();
          Tonyu.globals.$mainLayer.all(Tonyu.classes.kernel.Panel).die();
          if (Tonyu.globals.$wave>1) {
            Tonyu.globals.$wave--;
          }
          _this.Standby();
        })});
        
      },
      Pupgrade :function _trc_Main_Pupgrade() {
        var _this=this;
        
        _this.bWidth=256;
        new Tonyu.classes.kernel.Button({text: "💖",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: 0,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_3900() {
          
          if (Tonyu.globals.$money>=(Tonyu.globals.$healthPlice)) {
            Tonyu.globals.$money-=Tonyu.globals.$healthPlice;
            Tonyu.globals.$healthPlice*=2;
            Tonyu.globals.$towerHP+=10;
            Tonyu.globals.$tower.die();
            Tonyu.globals.$tower=new Tonyu.classes.user.Tower;
            
          }
        })});
        new Tonyu.classes.kernel.Button({text: "💪",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*1,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_4356() {
          
          if (Tonyu.globals.$money>=(Tonyu.globals.$armPlice)) {
            Tonyu.globals.$money-=Tonyu.globals.$armPlice;
            Tonyu.globals.$armPlice*=2;
            Tonyu.globals.$attack+=1;
            Tonyu.globals.$tower.die();
            Tonyu.globals.$tower=new Tonyu.classes.user.Tower;
            
          }
        })});
        new Tonyu.classes.kernel.Button({text: "❓",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*2,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_4786() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "❓",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*3,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_5006() {
          
        })});
        new Tonyu.classes.kernel.Label({template: "HEALTH\n\n\n\n\n\n"+"$healthPlice  PROTEIN",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*0,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "STRONG\n\n\n\n\n\n"+"$armPlice  PROTEIN",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*1,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  PROTEIN",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*2,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  PROTEIN",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*3,y: Tonyu.globals.$screenHeight-240-32});
      },
      fiber$Pupgrade :function* _trc_Main_f_Pupgrade(_thread) {
        var _this=this;
        
        _this.bWidth=256;
        new Tonyu.classes.kernel.Button({text: "💖",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: 0,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_3900() {
          
          if (Tonyu.globals.$money>=(Tonyu.globals.$healthPlice)) {
            Tonyu.globals.$money-=Tonyu.globals.$healthPlice;
            Tonyu.globals.$healthPlice*=2;
            Tonyu.globals.$towerHP+=10;
            Tonyu.globals.$tower.die();
            Tonyu.globals.$tower=new Tonyu.classes.user.Tower;
            
          }
        })});
        new Tonyu.classes.kernel.Button({text: "💪",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*1,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_4356() {
          
          if (Tonyu.globals.$money>=(Tonyu.globals.$armPlice)) {
            Tonyu.globals.$money-=Tonyu.globals.$armPlice;
            Tonyu.globals.$armPlice*=2;
            Tonyu.globals.$attack+=1;
            Tonyu.globals.$tower.die();
            Tonyu.globals.$tower=new Tonyu.classes.user.Tower;
            
          }
        })});
        new Tonyu.classes.kernel.Button({text: "❓",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*2,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_4786() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "❓",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*3,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_5006() {
          
        })});
        new Tonyu.classes.kernel.Label({template: "HEALTH\n\n\n\n\n\n"+"$healthPlice  PROTEIN",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*0,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "STRONG\n\n\n\n\n\n"+"$armPlice  PROTEIN",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*1,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  PROTEIN",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*2,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  PROTEIN",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*3,y: Tonyu.globals.$screenHeight-240-32});
        
      },
      Eupgrade :function _trc_Main_Eupgrade() {
        var _this=this;
        
        _this.print("@Main.Epup");
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: 0,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_5928() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*1,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_6151() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*2,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_6374() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*3,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_6597() {
          
        })});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*0,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*1,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*2,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*3,y: Tonyu.globals.$screenHeight-240-32});
      },
      fiber$Eupgrade :function* _trc_Main_f_Eupgrade(_thread) {
        var _this=this;
        
        _this.print("@Main.Epup");
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: 0,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_5928() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*1,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 32,onClick: (function anonymous_6151() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*2,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_6374() {
          
        })});
        new Tonyu.classes.kernel.Button({text: "----",fillStyle: "#fff8",strokeStyle: "#000",clickedStyle: "#888",left: _this.bWidth*3,top: Tonyu.globals.$screenHeight-256-32,width: _this.bWidth,height: 256,padding: 64,onClick: (function anonymous_6597() {
          
        })});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*0,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*1,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*2,y: Tonyu.globals.$screenHeight-240-32});
        new Tonyu.classes.kernel.Label({template: "BRANK\n\n\n\n\n\n"+"$brankPlice  EP",fillStyle: "#000",align: "center",size: 32,x: 128+_this.bWidth*3,y: Tonyu.globals.$screenHeight-240-32});
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}},"Alldie":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Standby":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Fight":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Healing":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Defeat":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Pupgrade":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}},"Eupgrade":{"nowait":false,"isMain":false,"vtype":{"params":[],"returnValue":null}}},"fields":{"fstart":{},"i":{},"bWidth":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Sam',
  shortName: 'Sam',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Sam_main() {
        var _this=this;
        
        _this.p=Tonyu.globals.$pat_pad128+4;
        _this.zOrder=1;
        _this.scrDice=_this.rnd(2);
        if (_this.scrDice==1) {
          _this.scrDice=_this.rnd(2);
          if (_this.scrDice==1) {
            _this.x=(- 256);
            _this.y=_this.rnd(Tonyu.globals.$screenHeight);
            
          } else {
            _this.x=(Tonyu.globals.$screenWidth)+256;
            _this.y=_this.rnd(Tonyu.globals.$screenHeight);
            
          }
          
        } else {
          _this.scrDice=_this.rnd(2);
          if (_this.scrDice==1) {
            _this.x=_this.rnd(Tonyu.globals.$screenWidth);
            _this.y=(- 128);
            
          } else {
            _this.x=_this.rnd(Tonyu.globals.$screenWidth);
            _this.y=(Tonyu.globals.$screenHeight)+128;
            
          }
          
        }
        ;
        
        _this.crashScale=0.5;
        _this.useObjectPool=true;
        _this.dir=0;
        _this.gauge=new Tonyu.classes.kernel.Panel({lifeKeeper: _this});
        _this.gauge.resize(100,10);
        _this.life=100;
        _this.hp=[10,10];
        _this.ldamage=(_this.life/_this.hp[0])*Tonyu.globals.$attack;
        while (true) {
          Tonyu.checkLoop();
          _this.cTower=_this.crashTo(Tonyu.classes.user.Tower);
          if (! _this.cTower) {
            _this.x+=_this.cos(_this.dir);
            _this.y+=_this.sin(_this.dir);
            _this.tx=Tonyu.globals.$tower.x;
            _this.ty=Tonyu.globals.$tower.y;
            _this.tdir=_this.atanxy(_this.tx-_this.x,_this.ty-_this.y);
            _this.d=_this.angleDiff(_this.dir,_this.tdir);
            if (_this.d>0) {
              _this.dir-=2;
            } else {
              _this.dir+=2;
            }
            
          }
          _this.gauge.x=_this.x;
          _this.gauge.y=_this.y-64;
          _this.gauge.fillStyle="#000";
          _this.gauge.fillRect(0,0,100,10);
          _this.gauge.fillStyle="#f00";
          _this.gauge.fillRect(1,1,_this.life-2,10-2);
          if (_this.life<=0) {
            Tonyu.globals.$protein=new Tonyu.classes.user.Item({x: _this.x,y: _this.y,p: Tonyu.globals.$pat_pad128+11});
            _this.die();
            
          }
          _this.cBullet=_this.crashTo(Tonyu.classes.user.Bullet);
          if (_this.cBullet) {
            _this.life-=_this.ldamage;
            
          }
          _this.update();
          
        }
      },
      fiber$main :function* _trc_Sam_f_main(_thread) {
        var _this=this;
        
        _this.p=Tonyu.globals.$pat_pad128+4;
        _this.zOrder=1;
        _this.scrDice=_this.rnd(2);
        if (_this.scrDice==1) {
          _this.scrDice=_this.rnd(2);
          if (_this.scrDice==1) {
            _this.x=(- 256);
            _this.y=_this.rnd(Tonyu.globals.$screenHeight);
            
          } else {
            _this.x=(Tonyu.globals.$screenWidth)+256;
            _this.y=_this.rnd(Tonyu.globals.$screenHeight);
            
          }
          
        } else {
          _this.scrDice=_this.rnd(2);
          if (_this.scrDice==1) {
            _this.x=_this.rnd(Tonyu.globals.$screenWidth);
            _this.y=(- 128);
            
          } else {
            _this.x=_this.rnd(Tonyu.globals.$screenWidth);
            _this.y=(Tonyu.globals.$screenHeight)+128;
            
          }
          
        }
        ;
        
        _this.crashScale=0.5;
        _this.useObjectPool=true;
        _this.dir=0;
        _this.gauge=new Tonyu.classes.kernel.Panel({lifeKeeper: _this});
        _this.gauge.resize(100,10);
        _this.life=100;
        _this.hp=[10,10];
        _this.ldamage=(_this.life/_this.hp[0])*Tonyu.globals.$attack;
        while (true) {
          yield null;
          _this.cTower=_this.crashTo(Tonyu.classes.user.Tower);
          if (! _this.cTower) {
            _this.x+=_this.cos(_this.dir);
            _this.y+=_this.sin(_this.dir);
            _this.tx=Tonyu.globals.$tower.x;
            _this.ty=Tonyu.globals.$tower.y;
            _this.tdir=_this.atanxy(_this.tx-_this.x,_this.ty-_this.y);
            _this.d=_this.angleDiff(_this.dir,_this.tdir);
            if (_this.d>0) {
              _this.dir-=2;
            } else {
              _this.dir+=2;
            }
            
          }
          _this.gauge.x=_this.x;
          _this.gauge.y=_this.y-64;
          _this.gauge.fillStyle="#000";
          _this.gauge.fillRect(0,0,100,10);
          _this.gauge.fillStyle="#f00";
          _this.gauge.fillRect(1,1,_this.life-2,10-2);
          if (_this.life<=0) {
            Tonyu.globals.$protein=new Tonyu.classes.user.Item({x: _this.x,y: _this.y,p: Tonyu.globals.$pat_pad128+11});
            _this.die();
            
          }
          _this.cBullet=_this.crashTo(Tonyu.classes.user.Bullet);
          if (_this.cBullet) {
            _this.life-=_this.ldamage;
            
          }
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}}},"fields":{"scrDice":{},"dir":{},"gauge":{},"life":{},"hp":{},"ldamage":{},"cTower":{},"tx":{},"ty":{},"tdir":{},"d":{},"cBullet":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Tower',
  shortName: 'Tower',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Tower_main() {
        var _this=this;
        
        _this.update();
        _this.p=Tonyu.globals.$pat_pad128+1;
        _this.zOrder=2;
        _this.x=Tonyu.globals.$screenWidth/2;
        _this.y=Tonyu.globals.$screenHeight/2;
        _this.crashScale=0.5;
        _this.useObjectPool=true;
        _this.lGauge=new Tonyu.classes.kernel.Panel;
        _this.lGauge.resize(400,32);
        _this.life=_this.clamp(400,0,400);
        Tonyu.globals.$hpMax=Tonyu.globals.$towerHP;
        Tonyu.globals.$hp=Tonyu.globals.$towerHP;
        _this.ldamage=(_this.life/Tonyu.globals.$hpMax);
        _this.c=0;
        _this.print("ldamage"+_this.ldamage);
        new Tonyu.classes.kernel.Label({template: "$hp/$hpMax",x: (Tonyu.globals.$screenWidth/2),y: 48,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#fff",align: "center"});
        _this.iGauge=new Tonyu.classes.kernel.Panel({lifeKeeper: _this});
        _this.iGauge.resize(100,10);
        _this.interval=_this.clamp(100,0,100);
        _this.ip=(120);
        _this.idamage=(_this.interval/_this.ip);
        _this.interval=0;
        _this.ip=0;
        while (true) {
          Tonyu.checkLoop();
          if (_this.getkey("a")==1) {
            _this.life-=_this.ldamage;
            Tonyu.globals.$hp-=1;
            
          }
          if (_this.crashTo(Tonyu.classes.user.Sam)&&_this.c<=0) {
            _this.c=30;
            _this.life-=_this.ldamage;
            Tonyu.globals.$hp-=1;
            if (Tonyu.globals.$hp<=0) {
              _this.die();
            }
            
          }
          if (_this.c>0) {
            _this.c--;
          }
          if (_this.c%2==0) {
            _this.alpha=255;
          } else {
            _this.alpha=0;
          }
          _this.lGauge.x=Tonyu.globals.$screenWidth/2;
          _this.lGauge.y=64;
          _this.lGauge.fillStyle="#000";
          _this.lGauge.fillRect(0,0,400,32);
          _this.lGauge.fillStyle="#f00";
          _this.lGauge.fillRect(1,1,_this.life-2,32-2);
          if (_this.interval<100) {
            _this.interval+=_this.idamage;
            _this.ip+=1;
            
          }
          if (Tonyu.globals.$touches[0].touched==0) {
            
            
          } else {
            if (_this.ip>120) {
              _this.print(_this.interval+"");
              _this.interval=0;
              _this.ip=0;
              new Tonyu.classes.user.Bullet({x: _this.x,y: _this.y,p: Tonyu.globals.$pat_pad128+8});
              
            }
          }
          _this.iGauge.x=Tonyu.globals.$screenWidth/2;
          _this.iGauge.y=_this.y+64;
          _this.iGauge.fillStyle="#000";
          _this.iGauge.fillRect(0,0,100,10);
          _this.iGauge.fillStyle="#0f0";
          _this.iGauge.fillRect(1,1,_this.interval-3,10-2);
          _this.update();
          
        }
      },
      fiber$main :function* _trc_Tower_f_main(_thread) {
        var _this=this;
        
        (yield* _this.fiber$update(_thread));
        _this.p=Tonyu.globals.$pat_pad128+1;
        _this.zOrder=2;
        _this.x=Tonyu.globals.$screenWidth/2;
        _this.y=Tonyu.globals.$screenHeight/2;
        _this.crashScale=0.5;
        _this.useObjectPool=true;
        _this.lGauge=new Tonyu.classes.kernel.Panel;
        _this.lGauge.resize(400,32);
        _this.life=_this.clamp(400,0,400);
        Tonyu.globals.$hpMax=Tonyu.globals.$towerHP;
        Tonyu.globals.$hp=Tonyu.globals.$towerHP;
        _this.ldamage=(_this.life/Tonyu.globals.$hpMax);
        _this.c=0;
        _this.print("ldamage"+_this.ldamage);
        new Tonyu.classes.kernel.Label({template: "$hp/$hpMax",x: (Tonyu.globals.$screenWidth/2),y: 48,size: 32,layer: Tonyu.globals.$mainLayer,fillStyle: "#fff",align: "center"});
        _this.iGauge=new Tonyu.classes.kernel.Panel({lifeKeeper: _this});
        _this.iGauge.resize(100,10);
        _this.interval=_this.clamp(100,0,100);
        _this.ip=(120);
        _this.idamage=(_this.interval/_this.ip);
        _this.interval=0;
        _this.ip=0;
        while (true) {
          yield null;
          if (_this.getkey("a")==1) {
            _this.life-=_this.ldamage;
            Tonyu.globals.$hp-=1;
            
          }
          if (_this.crashTo(Tonyu.classes.user.Sam)&&_this.c<=0) {
            _this.c=30;
            _this.life-=_this.ldamage;
            Tonyu.globals.$hp-=1;
            if (Tonyu.globals.$hp<=0) {
              _this.die();
            }
            
          }
          if (_this.c>0) {
            _this.c--;
          }
          if (_this.c%2==0) {
            _this.alpha=255;
          } else {
            _this.alpha=0;
          }
          _this.lGauge.x=Tonyu.globals.$screenWidth/2;
          _this.lGauge.y=64;
          _this.lGauge.fillStyle="#000";
          _this.lGauge.fillRect(0,0,400,32);
          _this.lGauge.fillStyle="#f00";
          _this.lGauge.fillRect(1,1,_this.life-2,32-2);
          if (_this.interval<100) {
            _this.interval+=_this.idamage;
            _this.ip+=1;
            
          }
          if (Tonyu.globals.$touches[0].touched==0) {
            
            
          } else {
            if (_this.ip>120) {
              _this.print(_this.interval+"");
              _this.interval=0;
              _this.ip=0;
              new Tonyu.classes.user.Bullet({x: _this.x,y: _this.y,p: Tonyu.globals.$pat_pad128+8});
              
            }
          }
          _this.iGauge.x=Tonyu.globals.$screenWidth/2;
          _this.iGauge.y=_this.y+64;
          _this.iGauge.fillStyle="#000";
          _this.iGauge.fillRect(0,0,100,10);
          _this.iGauge.fillStyle="#0f0";
          _this.iGauge.fillRect(1,1,_this.interval-3,10-2);
          (yield* _this.fiber$update(_thread));
          
        }
        
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false,"isMain":true,"vtype":{"params":[],"returnValue":null}}},"fields":{"lGauge":{},"life":{},"ldamage":{},"c":{},"iGauge":{},"interval":{},"ip":{},"idamage":{}}}
});

});

//# sourceMappingURL=concat.js.map